<template>
  <card title="Список пользователей">
    <data-table
      :value="users"
      :paginator="false"
      class="p-datatable-users"
      :rows="10"
      data-key="id"
      :row-hover="true"
      filter-display="menu"
      :loading="false"
      responsive-layout="scroll"
    >
      <template #empty>
        No users found.
      </template>
      <template #loading>
        Loading users data. Please wait.
      </template>
      <prime-column
        field="email"
        header="Почта"
        data-type="text"
        style="min-width: 8rem"
      >
        <template #body="{data}">
          {{ data.email }}
        </template>
      </prime-column>

      <prime-column
        field="role"
        header="Роль"
        data-type="text"
        style="min-width: 8rem"
      >
        <template #body="{data}">
          {{ formatRole(data.role) }}
        </template>
      </prime-column>
      <prime-column header-style="width: 4rem; text-align: center" body-style="text-align: center; overflow: visible">
        <template #body="{data}">
          <div class="actions-button">
            <prime-button
              type="button"
              icon="pi pi-cog"
              @click="selectedUser = data"
            />
            <prime-button
              type="button"
              icon="pi pi-trash"
              class="p-button-danger"
              @click="deleteConfirmation(data)"
            />
          </div>
        </template>
      </prime-column>
    </data-table>

    <prime-dialog
      v-model:visible="isSelected"
      header="Редактирование пользователя"
      :modal="true"
    >
      <edit-user
        :user="selectedUser"
        @close="isSelected = false"
        @update="updateUser"
      />
    </prime-dialog>
  </card>
</template>

<script lang="ts">
import PrimeButton from 'primevue/button/Button.vue';
import PrimeColumn from 'primevue/column/Column.vue';
import DataTable from 'primevue/datatable/DataTable.vue';
import PrimeDialog from 'primevue/dialog/Dialog.vue';
import { defineComponent } from 'vue';
import { deleteUser, getUsers } from '@/api/handler/user';
import Card from '@/components/Card.vue';
import EditUser from '@/components/users/EditUser.vue';
import { User } from '@/models/user';

interface Data {
  users: User[];
  selectedUser: User | null;
}

export default defineComponent({
  name: 'users',
  components: {
    PrimeDialog,
    DataTable,
    PrimeColumn,
    PrimeButton,
    EditUser,
    Card,
  },
  data(): Data {
    return {
      users: [],
      selectedUser: null,
    };
  },
  computed: {
    isSelected: {
      get(): boolean {
        return this.selectedUser !== null;
      },
      set(isSelected: boolean) {
        if (!isSelected) {
          this.selectedUser = null;
        }
      },
    },
  },
  async created() {
    const res = await getUsers();
    if (res.__state === 'success') {
      this.users = res.data;
    }
  },
  methods: {
    formatRole(value: User['role']) {
      if (value === 2) {
        return 'Админ';
      }
      return 'Пользователь';
    },
    deleteConfirmation(user: User) {
      this.$confirm.require({
        message: `Вы уверены, что хотите удалить пользователя ${user.email}?`,
        header: 'Удаление',
        icon: 'pi pi-exclamation-triangle',
        accept: () => {
          this.delete(user);
        },
      });
    },
    async delete(deletedUser: User) {
      const res = await deleteUser(deletedUser);
      if (res.__state === 'success') {
        const index = this.users.findIndex(user => user.id === deletedUser.id);
        if (index === -1) {
          return;
        }

        this.users.splice(index, 1);
      }
    },
    updateUser(updatedUser: User) {
      const index = this.users.findIndex(user => user.id === updatedUser.id);
      if (index === -1) {
        return;
      }

      this.users.splice(index, 1, updatedUser);
    },
  },
});
</script>

<style lang="scss" scoped>
::v-deep(.p-paginator) {
    .p-paginator-current {
        margin-left: auto;
    }
}

::v-deep(.p-progressbar) {
    height: .5rem;
    background-color: #D8DADC;

    .p-progressbar-value {
        background-color: #607D8B;
    }
}

::v-deep(.p-datepicker) {
    min-width: 25rem;

    td {
        font-weight: 400;
    }
}

::v-deep(.p-datatable.p-datatable-users) {
    .p-datatable-header {
        padding: 1rem;
        text-align: left;
        font-size: 1.5rem;
    }

    .p-paginator {
        padding: 1rem;
    }

    .p-datatable-thead > tr > th {
        text-align: left;
    }

    .p-datatable-tbody > tr > td {
        cursor: auto;
    }

    .p-dropdown-label:not(.p-placeholder) {
        text-transform: uppercase;
    }
}

.actions-button {
  display: flex;
  align-items: center;

  & > *:not(:last-child) {
    margin-right: 8px;
  }
}
</style>
